package edu.sc.seis.cormorant.event;

import java.util.List;

import edu.sc.seis.fissuresUtil.cache.CacheEvent;
import edu.sc.seis.fissuresUtil.database.NotFound;
import edu.sc.seis.fissuresUtil.flow.querier.EventFinderQuery;
import edu.sc.seis.fissuresUtil.hibernate.EventDB;


public class EventDBDataAccess implements EventDataAccess {

    public EventDBDataAccess(EventDB edb) {
        this.edb = edb;
    }

    public CacheEvent[] getByName(String name) {
        return edb.getByName(name);
    }
    
    public String[] getCatalogs() {
        return edb.getCatalogs();
    }

    public String[] getCatalogsFor(String contributor) {
        return edb.getCatalogsFor(contributor);
    }

    public String[] getContributors() {
        return edb.getContributors();
    }

    public CacheEvent getEvent(int dbid) throws NotFound {
        return edb.getEvent(dbid);
    }

    public int[] query(EventFinderQuery q) {
        List<CacheEvent> events = edb.query(q);
        int[] out = new int[events.size()];
        for(int i = 0; i < out.length; i++) {
            out[i] = events.get(i).getDbid();
        }
        return out;
    }
    
    EventDB edb;
}
