package edu.sc.seis.cormorant.event;

import edu.iris.Fissures.IfEvent.Event;
import edu.iris.Fissures.IfEvent.EventAttr;
import edu.iris.Fissures.IfEvent.EventChannelFinder;
import edu.iris.Fissures.IfEvent.EventFactory;
import edu.iris.Fissures.IfEvent.EventFactoryPOA;
import edu.iris.Fissures.IfEvent.EventFinder;
import edu.iris.Fissures.IfEvent.EventHelper;
import edu.sc.seis.fissuresUtil.cache.CacheEvent;
import edu.sc.seis.fissuresUtil.hibernate.EventDB;

public class EventFactoryImpl extends EventFactoryPOA {

    public EventFactoryImpl(EventDB jdbcEventAccess,
            org.omg.PortableServer.POA poa) {
        this.jdbcEventAccess = jdbcEventAccess;
        this.poa = poa;
    }

    public Event create(EventAttr attributes,
                        edu.iris.Fissures.AuditInfo[] audit_info) {
        logger.debug("In The method create");
        Event event = null;
        long eventid;
        CacheEvent cacheEvent = new CacheEvent(attributes, null);
        eventid = jdbcEventAccess.put(cacheEvent);
        logger.debug("The event id obtained is " + eventid);
        org.omg.CORBA.Object obj = poa.create_reference_with_id(new Long(eventid).toString()
                                                                        .getBytes(),
                                                                EventHelper.id());
        logger.debug("After creating the obj reference with id");
        event = EventHelper.narrow(obj);
        if(event == null) logger.debug("The event to be returned is null");
        else logger.debug("IOR: " + _orb().object_to_string(event));
        // return event;
        return event;
    }

    public EventFactory a_factory() {
        return eventFactory;
    }

    public EventFinder a_finder() {
        return eventFinder;
    }

    public EventChannelFinder a_channel_finder() {
        return null;
    }

    public void setEventFinder(EventFinder eventFinder) {
        this.eventFinder = eventFinder;
    }

    public void setEventFactory(EventFactory eventFactory) {
        this.eventFactory = eventFactory;
    }

    private EventFinder eventFinder = null;

    private EventFactory eventFactory = null;

    private EventDB jdbcEventAccess;

    private org.omg.PortableServer.POA poa;

    private static final org.slf4j.Logger logger = org.slf4j.LoggerFactory.getLogger(EventFactoryImpl.class);
}// EventFactoryImpl
