package edu.sc.seis.cormorant.seismogram;

import org.omg.CORBA.NO_IMPLEMENT;

import edu.iris.Fissures.FissuresException;
import edu.iris.Fissures.Time;
import edu.iris.Fissures.IfSeismogramDC.DataCenterCallBack;
import edu.iris.Fissures.IfSeismogramDC.DataCenterPOA;
import edu.iris.Fissures.IfSeismogramDC.LocalSeismogram;
import edu.iris.Fissures.IfSeismogramDC.RequestFilter;
import edu.iris.Fissures.model.MicroSecondDate;
import edu.iris.Fissures.model.TimeInterval;
import edu.iris.Fissures.seismogramDC.LocalSeismogramImpl;
import edu.sc.seis.fissuresUtil.mockFissures.IfSeismogramDC.MockSeismogram;


public class MockSeismogramServer extends DataCenterPOA {
    double samplesPerSecond = 100;
    int missingSamples = 543;
    int samplesPerSpike = 10;
    public RequestFilter[] available_data(RequestFilter[] a_filterseq) {
        return a_filterseq;
    }

    public String request_seismograms(RequestFilter[] a_filterseq,
                                      DataCenterCallBack a_client,
                                      boolean long_lived,
                                      Time expiration_time) throws FissuresException {
        throw new NO_IMPLEMENT();
    }

    public LocalSeismogram[] retrieve_seismograms(RequestFilter[] a_filterseq) throws FissuresException {

        TimeInterval traceLength = new TimeInterval(new MicroSecondDate(a_filterseq[0].start_time),
                                                    new MicroSecondDate(a_filterseq[0].end_time));
        LocalSeismogramImpl seis =MockSeismogram.createRaggedSpike(new MicroSecondDate(a_filterseq[0].start_time),
                                                                   traceLength,
                                                                   samplesPerSpike,
                                                                   missingSamples,
                                                                   a_filterseq[0].channel_id,
                                                                   samplesPerSecond);
        seis.begin_time = a_filterseq[0].start_time;
        return new LocalSeismogramImpl[] { seis };
    }

    public String queue_seismograms(RequestFilter[] a_filterseq) throws FissuresException {
        throw new NO_IMPLEMENT();
    }

    public LocalSeismogram[] retrieve_queue(String a_request) throws FissuresException {
        throw new NO_IMPLEMENT();
    }

    public void cancel_request(String a_request) throws FissuresException {
        throw new NO_IMPLEMENT();
    }

    public String request_status(String a_request) throws FissuresException {
        throw new NO_IMPLEMENT();
    }
    
}
